// PID Controller - Control Position of DC Motor Example
// Tutorial is available here: https://forum.phpoc.com/blogs/iot-lover/1289-arduino-pid-controller-auto-tuning-library-and-example-for-dc-motor 

#include <Phpoc.h>
#include <PhpocExpansion.h>
#include <Pid.h>

DcMotorPID dcPid1(1, 1);
//DcMotorPID dcPid2(1, 2);

long targetPosition;
long position;
int count = 0;

void setup(){
  Serial.begin(9600);
  while(!Serial)
    ;

  //Phpoc.begin(PF_LOG_SPI | PF_LOG_NET);
  Phpoc.begin();
  Expansion.begin(460800);

  dcPid1.setPeriod(10000);
  dcPid1.setEncoderPSR(64);
  dcPid1.setDecay(0);
  dcPid1.setFilterFrequency(5000);
  dcPid1.setScaleFactor(16); // depending on motor, should test manually to have the best value 
  dcPid1.setIntegralLimit(-6000, 6000);
  dcPid1.begin(PID_POSITION);

  /*----------- check enc pol-------------- */
  int pwm = 0; long position = 0;
  while(!position)
  {
    pwm += 10;
    dcPid1.setWidth(pwm);
    position = dcPid1.getEncoderPosition();
    delay(1);
  }

  if(position < 0)
    dcPid1.setEncoderPolarity(-1);

  dcPid1.setWidth(0);

  //dcPid1.setGain(24.099171193725, 10.78947680748, 0.0617886);

  /* PID auto-tuning */
  dcPid1.beginTune();
  while(!dcPid1.loopTune())
    ;

  dcPid1.setEncoderPosition(0);

  //Serial.print(F("PID TUNED Kp: ")); Serial.println(dcPid1.getKp());
  //Serial.print(F("PID TUNED Ki: ")); Serial.println(dcPid1.getKi());
  //Serial.print(F("PID TUNED Kd: ")); Serial.println(dcPid1.getKd());

  Serial.print(F("Target_Position"));
  Serial.print(" ");
  Serial.println(F("Real_Position"));
}

void loop(){
  if(count == 0)
    targetPosition = 3000;
  else if(count == 1000)
    targetPosition = 4000;
  else if(count == 2000)
    targetPosition = -2000;

  if(count < 3000) {
    position = dcPid1.loop(targetPosition);

    //position = dcPid1.getEncoderPosition();
    Serial.print(targetPosition);
    Serial.print(" ");
    Serial.println(position);
    count++;
  }
}