// PID Controller - Control Position of DC Motor Example
// Tutorial is available here: https://forum.phpoc.com/blogs/iot-lover/1289-arduino-pid-controller-auto-tuning-library-and-example-for-dc-motor 

#include <Phpoc.h>
#include <PhpocExpansion.h>
#include <Pid.h>

DcMotorPID dcPid1(1, 1);
//DcMotorPID dcPid2(1, 2);

int targetSpeed;
int speed;
int count = 0;

void setup(){
  Serial.begin(9600);
  while(!Serial)
    ;

  //Phpoc.begin(PF_LOG_SPI | PF_LOG_NET);
  Phpoc.begin();
  Expansion.begin(460800);

  dcPid1.setPeriod(10000);
  dcPid1.setEncoderPSR(64);
  dcPid1.setDecay(0);
  dcPid1.setFilterFrequency(5000);
  dcPid1.setScaleFactor(8); // depending on motor, should test manually to have the best value 
  dcPid1.setIntegralLimit(-80000, 80000);
  dcPid1.setIntegralTermLimit(-2000, 2000);
  dcPid1.begin(PID_SPEED);

  //dcPid1.setGain(1, 0.1, 0);

  /* PID auto-tuning */
  dcPid1.beginTune();
  while(!dcPid1.loopTune())
    ;

  //Serial.print(F("PID TUNED Kp: ")); Serial.println(dcPid1.getKp());
  //Serial.print(F("PID TUNED Ki: ")); Serial.println(dcPid1.getKi());
  //Serial.print(F("PID TUNED Kd: ")); Serial.println(dcPid1.getKd());

  delay(2000);

  Serial.print(F("Target Speed"));
  Serial.print(" ");
  Serial.println(F("Real Speed"));
}
}

void loop(){
  if(count == 0)
    targetSpeed = 3000;
  else if(count == 1000)
    targetSpeed = 5000;
  else if(count == 2000)
    targetSpeed = 1000;

  if(count < 3000) {
    speed = dcPid1.loop(targetSpeed);

    //speed = dcPid1.getSpeed();
    Serial.print(targetSpeed);
    Serial.print(" ");
    Serial.println(speed);
    count++;
  } else {
    dcPid1.setWidth(0);
  }
}